//
//  PresetController.swift
//  MassageMe
//
//  Created by Megan Leszczynski on 11/19/16.
//  Copyright © 2016 Harry+Margi. All rights reserved.
//

import UIKit
import CoreBluetooth
import ChameleonFramework

// protocol definitions
let stop_msg: UInt8 = 0
let preset_msg: UInt8 = 1
let full_back: UInt8 = 0
let upper_back: UInt8 = 1
let lower_back: UInt8 = 2
let spine: UInt8 = 3
let eot: UInt8 = 127 // end of transmission

class PresetController: UIViewController, UIPickerViewDataSource, UIPickerViewDelegate {

   var pickerView:UIPickerView?
   let pickerData =  ["Full Back", "Upper Back", "Lower Back", "Spine"]
   var imageView = UIImageView(image: UIImage(named: "vestoutline2.png")!)
   let screenSize: CGRect = UIScreen.mainScreen().bounds
   
   var running: Bool = false
   var message: [UInt8] = [preset_msg, full_back, eot]
   
   var disk1:UIButton?
   var disk2:UIButton?
   var disk3:UIButton?
   var disk4:UIButton?
   var disk5:UIButton?
   var disk6:UIButton?
   var disk7:UIButton?
   var disk8:UIButton?
   var disk9:UIButton?
   var disk10:UIButton?
   var disk11:UIButton?
   var disk12:UIButton?
   var disk13:UIButton?
   var disk14:UIButton?
   var disk15:UIButton?
   var disk16:UIButton?
   
   func makeDisk(x_val: Int, y_val: Int)-> UIButton {
      let disk = UIButton(frame: CGRect(x: x_val, y: y_val, width: 10, height: 10))
      disk.layer.cornerRadius = disk.bounds.size.width / 2.0;
      disk.backgroundColor = HexColor("8b008B")
      return disk
   }
   
   override func viewDidLoad() {
      self.view.backgroundColor = UIColor.blackColor()
        
      let rect = CGRect(
            x:0,
            y:330,
            width: screenSize.width-10,
            height: 120)
      pickerView = UIPickerView(frame:rect)
      pickerView?.center.x = self.view.center.x
      pickerView!.backgroundColor = UIColor.clearColor()
      pickerView!.clipsToBounds = true
      pickerView!.layer.borderWidth = 1
      pickerView!.dataSource = self
      pickerView!.delegate = self
      self.view.addSubview(pickerView!)
      
      imageView.frame = CGRectMake(0,75,200,250)
      imageView.center.x = self.view.center.x
      self.view.addSubview(imageView)
      
      let startButton = UIButton(frame: CGRect(x: 100, y: 475, width: 250, height: 50))
      startButton.backgroundColor = UIColor.blackColor()
      startButton.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
      startButton.layer.cornerRadius = 25
      startButton.layer.borderColor = HexColor("8b008B").CGColor
      startButton.layer.borderWidth = 1;
      startButton.clipsToBounds = true
      startButton.setTitle("START MASSAGE", forState: UIControlState.Normal)
      startButton.addTarget(self, action: #selector(startPushed), forControlEvents: .TouchUpInside)
      startButton.center.x = self.view.center.x
      self.view.addSubview(startButton)
      
      disk1 = makeDisk(110, y_val: 120) // u
      disk2 = makeDisk(110, y_val: 155)
      disk3 = makeDisk(110, y_val: 225) // l
      disk4 = makeDisk(110, y_val: 250)
      disk5 = makeDisk(135, y_val: 130) // u
      disk6 = makeDisk(135, y_val: 155)
      disk7 = makeDisk(135, y_val: 225) // l
      disk8 = makeDisk(135, y_val: 250)
      disk9 = makeDisk(200, y_val: 120) // u
      disk10 = makeDisk(200, y_val: 155)
      disk11 = makeDisk(200, y_val: 225) // l
      disk12 = makeDisk(200, y_val: 250)
      disk13 = makeDisk(175, y_val: 130) // u
      disk14 = makeDisk(175, y_val: 155)
      disk15 = makeDisk(175, y_val: 225) // l
      disk16 = makeDisk(175, y_val: 250)
      self.view.addSubview(disk1!)
      self.view.addSubview(disk2!)
      self.view.addSubview(disk3!)
      self.view.addSubview(disk4!)
      self.view.addSubview(disk5!)
      self.view.addSubview(disk6!)
      self.view.addSubview(disk7!)
      self.view.addSubview(disk8!)
      self.view.addSubview(disk9!)
      self.view.addSubview(disk10!)
      self.view.addSubview(disk11!)
      self.view.addSubview(disk12!)
      self.view.addSubview(disk13!)
      self.view.addSubview(disk14!)
      self.view.addSubview(disk15!)
      self.view.addSubview(disk16!)
    }
   
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    func numberOfComponentsInPickerView(pickerView: UIPickerView) -> Int {
        return 1
    }
    
    
    func pickerView(pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        return pickerData.count
    }
    
    func pickerView(pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        return pickerData[row]
    }
    
    func pickerView(pickerView: UIPickerView, attributedTitleForRow row: Int, forComponent component: Int) -> NSAttributedString? {
        let attributedString = NSAttributedString(string: pickerData[row], attributes: [NSForegroundColorAttributeName : UIColor.whiteColor()])
        return attributedString
    }
   
   // Catpure the picker view selection
   func pickerView(pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int) {
      // full back
      if (row == 0){
         disk1!.alpha = 1
         disk2!.alpha = 1
         disk3!.alpha = 1
         disk4!.alpha = 1
         disk5!.alpha = 1
         disk6!.alpha = 1
         disk7!.alpha = 1
         disk8!.alpha = 1
         disk9!.alpha = 1
         disk10!.alpha = 1
         disk11!.alpha = 1
         disk12!.alpha = 1
         disk13!.alpha = 1
         disk14!.alpha = 1
         disk15!.alpha = 1
         disk16!.alpha = 1
         // make message
         message = [preset_msg, full_back, eot]
      } // upper back
      else if (row == 1){
         disk1!.alpha = 1
         disk2!.alpha = 1
         disk3!.alpha = 0
         disk4!.alpha = 0
         disk5!.alpha = 1
         disk6!.alpha = 1
         disk7!.alpha = 0
         disk8!.alpha = 0
         disk9!.alpha = 1
         disk10!.alpha = 1
         disk11!.alpha = 0
         disk12!.alpha = 0
         disk13!.alpha = 1
         disk14!.alpha = 1
         disk15!.alpha = 0
         disk16!.alpha = 0
         // make message
         message = [preset_msg, upper_back, eot]
      } // lower back
      else if (row == 2){
         disk1!.alpha = 0
         disk2!.alpha = 0
         disk3!.alpha = 1
         disk4!.alpha = 1
         disk5!.alpha = 0
         disk6!.alpha = 0
         disk7!.alpha = 1
         disk8!.alpha = 1
         disk9!.alpha = 0
         disk10!.alpha = 0
         disk11!.alpha = 1
         disk12!.alpha = 1
         disk13!.alpha = 0
         disk14!.alpha = 0
         disk15!.alpha = 1
         disk16!.alpha = 1
         // make message
         message = [preset_msg, lower_back, eot]
      } // spine
      else {
         disk1!.alpha = 0
         disk2!.alpha = 0
         disk3!.alpha = 0
         disk4!.alpha = 0
         disk5!.alpha = 1
         disk6!.alpha = 1
         disk7!.alpha = 1
         disk8!.alpha = 1
         disk9!.alpha = 0
         disk10!.alpha = 0
         disk11!.alpha = 0
         disk12!.alpha = 0
         disk13!.alpha = 1
         disk14!.alpha = 1
         disk15!.alpha = 1
         disk16!.alpha = 1
         // make message
         message = [preset_msg, spine, eot]
      }
   }
   
   func startPushed(sender: UIButton) {
      if serial.isReady && !running {
         serial.sendBytesToDevice(message)
         print(message)
         running = true
         // change to stop massage option
         sender.backgroundColor = HexColor("8b008B")
         sender.setTitleColor(.whiteColor(), forState: .Normal)
         sender.setTitle("STOP MASSAGE", forState: .Normal)
         pickerView?.userInteractionEnabled = false
      }
      else if (running){ // stop
         running = false
         sender.setTitle("START MASSAGE", forState: .Normal)
         sender.backgroundColor = UIColor.blackColor()
         sender.setTitleColor(HexColor("8b008B"), forState: UIControlState.Normal)
         serial.sendBytesToDevice([stop_msg, eot])
         print([stop_msg, eot])
         pickerView?.userInteractionEnabled = true
      }
   }

}


